using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using mshtml;

namespace RF.Demo
{
	public class MainForm : System.Windows.Forms.Form
	{
		private object _empty = System.Reflection.Missing.Value;
		private IHTMLDocument2 _doc;
		private AxSHDocVw.AxWebBrowser axWebBrowser1;
		private System.Windows.Forms.ListBox listStatus;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.LinkLabel lnkRF;

		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			InitializeComponent();

			axWebBrowser1.Navigate("about:blank", ref _empty, ref _empty, ref _empty, ref _empty);
			_doc = axWebBrowser1.Document as IHTMLDocument2;

			//wait for document to load
			while (_doc.body == null) Application.DoEvents();

			//write the HTML to the document's body
			_doc.body.innerHTML = "<a href=\"http://www.ryanfarley.com/\" target=_blank><img src=\"http://files.farleyzone.com/images/rfsmall.jpg\" border=0></a><br>" + 
							      "<form id=\"MainForm\">This is some text.<br><br>" +
				                  "<input type=button id=\"btnTest1\" value=\"Button #1\">&nbsp;" + 
								  "<input type=button id=\"btnTest2\" value=\"Button #2\"><br><br>" + 
							      "<a id=\"lnkTest\" style=\"text-decoration: underline; cursor: hand; color: blue;\">Test</a>" + 
							      "</form>";
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.axWebBrowser1 = new AxSHDocVw.AxWebBrowser();
			this.listStatus = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lnkRF = new System.Windows.Forms.LinkLabel();
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).BeginInit();
			this.SuspendLayout();
			// 
			// axWebBrowser1
			// 
			this.axWebBrowser1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.axWebBrowser1.Enabled = true;
			this.axWebBrowser1.Location = new System.Drawing.Point(8, 8);
			this.axWebBrowser1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
			this.axWebBrowser1.Size = new System.Drawing.Size(432, 328);
			this.axWebBrowser1.TabIndex = 0;
			// 
			// listStatus
			// 
			this.listStatus.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.listStatus.Location = new System.Drawing.Point(8, 344);
			this.listStatus.Name = "listStatus";
			this.listStatus.ScrollAlwaysVisible = true;
			this.listStatus.Size = new System.Drawing.Size(432, 82);
			this.listStatus.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label1.Location = new System.Drawing.Point(8, 432);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Demo provided by: ";
			// 
			// lnkRF
			// 
			this.lnkRF.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lnkRF.Location = new System.Drawing.Point(104, 432);
			this.lnkRF.Name = "lnkRF";
			this.lnkRF.Size = new System.Drawing.Size(80, 16);
			this.lnkRF.TabIndex = 3;
			this.lnkRF.TabStop = true;
			this.lnkRF.Text = "ryanfarley.com";
			this.lnkRF.VisitedLinkColor = System.Drawing.Color.Blue;
			this.lnkRF.Click += new System.EventHandler(this.lnkRF_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 450);
			this.Controls.Add(this.lnkRF);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.listStatus);
			this.Controls.Add(this.axWebBrowser1);
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Browser Demo 2 - Interactive HTML";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			_doc.onclick = this;
			_doc.onmouseover = this;
			_doc.onmouseout = this;
		}

		[DispId(0)]
		public void DispatchDefault()
		{
			HTMLWindow2 win = (HTMLWindow2)_doc.parentWindow;

			string eventtype = win.@event.type;
			string elementid = win.@event.srcElement.id;
			string elementtype = win.@event.srcElement.tagName;

			listStatus.SelectedIndex = listStatus.Items.Add(string.Format("Element ID: {0} ({1}) Event: {2}", elementid, elementtype, eventtype));
	
			switch (elementid)
			{
				case "btnTest1":
					if (eventtype.Equals("click")) MessageBox.Show(this, "Button #1 was clicked.", "C# MessageBox");
					break;
				case "btnTest2":
					if (eventtype.Equals("click")) MessageBox.Show(this, "Button #2 was clicked.", "C# MessageBox");
					break;
				case "lnkTest":
					if (eventtype.Equals("click")) MessageBox.Show(this, "Link 'Test' was clicked.", "C# MessageBox");
					break;
			}
		}

		private void lnkRF_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.ryanfarley.com/");
		}
	}
}
